
-- # import Property
-- # import GHC.Base
-- # import GHC.Base-Models
-- # import GHC.Num
-- # import E0

Stack = "GHC.Base::[]" "GHC.Base::Int"
Code = "GHC.Base::[]" "E0::Op"
exec = "E0.exec"
comp = "E0.comp"
eval = "E0.eval"

data Expr : Set where
  Val : "GHC.Base:Int" -> Expr
  Add : Expr -> Expr -> Expr

expr : Expr -> "E0:Expr"
expr (Val n)	= "E0.Val" n
expr (Add x y)	= "E0.Add" (expr x) (expr y)

-- Generalized compiler correctness (avoids underflow issues)
thm : (e : Expr) -> (s : Stack) -> (ops : Code) ->
       let e' = expr e in
       exec s ("GHC.Base.++" (comp e') ops) ==
       exec ("GHC.Base.:" (eval e') s) ops

thm (Val n) s ops     = cover-plugin( include "E0", include "GHC.Base" )
thm (Add e1 e2) s ops = cover-plugin( include "E0", include "GHC.Base"
 				    , rem1, rem2
				    , "++ assoc"
				    , thm e1, thm e2
				    )
  where
	rem1 : (n, m : "GHC.Base:Int") -> (s' : Stack) -> (ops' : Code) ->
	       "E0.exec" ("GHC.Base.:" m ("GHC.Base.:" n s'))
			 ("GHC.Base.:" "E0.ADD" ops')
		  == "E0.exec" ("GHC.Base.:" ("GHC.Base.plusInt" n m) s') ops'
	rem1 = cover-plugin( include "E0", include "GHC.Num" )

	rem2 : (x, y : "E0:Expr") ->
		eval ("E0.Add" x y) == "GHC.Base.plusInt" (eval x) (eval y)
	rem2 = cover-plugin( include "E0", include "GHC.Num" )

