{-# OPTIONS -fglasgow-exts -cpp #-}
{-| There are three shift\/reduce conflicts:

    > \x -> x + y

    can be parsed (incorrectly) as @(\\x -> x) + y@ or
    (correctly) as @\\x -> x + y@. The parser will @shift@ and hence do the
    right thing. The same problem occurs for @`op`@ and @->@ in place of @+@.
-}
module Syntax.Parser (
    -- * Exported Functions
    parse
    , parseFile
    , parseLiterate
    , parseLiterateFile
    , programParser
    , termParser
{-  REMOVE_IF_HADDOCK
    -- * Private Functions
    , mkLam
    , mkPi
    , mkInfix
    REMOVE_IF_HADDOCK -}
    ) where

import Syntax.Position
import Syntax.ParseMonad
import Syntax.Concrete
import Syntax.Lexer

import Utils.Monads
import Array
#if __GLASGOW_HASKELL__ >= 503
import GHC.Exts
#else
import GlaExts
#endif

-- parser produced by Happy Version 1.15

newtype HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32 = HappyAbsSyn (() -> ())
happyIn5 :: t5 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn5 x = unsafeCoerce# x
{-# INLINE happyIn5 #-}
happyOut5 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t5
happyOut5 x = unsafeCoerce# x
{-# INLINE happyOut5 #-}
happyIn6 :: t6 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn6 x = unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t6
happyOut6 x = unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: t7 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn7 x = unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t7
happyOut7 x = unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: t8 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn8 x = unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t8
happyOut8 x = unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: t9 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn9 x = unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t9
happyOut9 x = unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyIn10 :: t10 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn10 x = unsafeCoerce# x
{-# INLINE happyIn10 #-}
happyOut10 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t10
happyOut10 x = unsafeCoerce# x
{-# INLINE happyOut10 #-}
happyIn11 :: t11 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn11 x = unsafeCoerce# x
{-# INLINE happyIn11 #-}
happyOut11 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t11
happyOut11 x = unsafeCoerce# x
{-# INLINE happyOut11 #-}
happyIn12 :: t12 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn12 x = unsafeCoerce# x
{-# INLINE happyIn12 #-}
happyOut12 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t12
happyOut12 x = unsafeCoerce# x
{-# INLINE happyOut12 #-}
happyIn13 :: t13 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn13 x = unsafeCoerce# x
{-# INLINE happyIn13 #-}
happyOut13 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t13
happyOut13 x = unsafeCoerce# x
{-# INLINE happyOut13 #-}
happyIn14 :: t14 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn14 x = unsafeCoerce# x
{-# INLINE happyIn14 #-}
happyOut14 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t14
happyOut14 x = unsafeCoerce# x
{-# INLINE happyOut14 #-}
happyIn15 :: t15 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn15 x = unsafeCoerce# x
{-# INLINE happyIn15 #-}
happyOut15 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t15
happyOut15 x = unsafeCoerce# x
{-# INLINE happyOut15 #-}
happyIn16 :: t16 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn16 x = unsafeCoerce# x
{-# INLINE happyIn16 #-}
happyOut16 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t16
happyOut16 x = unsafeCoerce# x
{-# INLINE happyOut16 #-}
happyIn17 :: t17 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn17 x = unsafeCoerce# x
{-# INLINE happyIn17 #-}
happyOut17 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t17
happyOut17 x = unsafeCoerce# x
{-# INLINE happyOut17 #-}
happyIn18 :: t18 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn18 x = unsafeCoerce# x
{-# INLINE happyIn18 #-}
happyOut18 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t18
happyOut18 x = unsafeCoerce# x
{-# INLINE happyOut18 #-}
happyIn19 :: t19 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn19 x = unsafeCoerce# x
{-# INLINE happyIn19 #-}
happyOut19 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t19
happyOut19 x = unsafeCoerce# x
{-# INLINE happyOut19 #-}
happyIn20 :: t20 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn20 x = unsafeCoerce# x
{-# INLINE happyIn20 #-}
happyOut20 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t20
happyOut20 x = unsafeCoerce# x
{-# INLINE happyOut20 #-}
happyIn21 :: t21 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn21 x = unsafeCoerce# x
{-# INLINE happyIn21 #-}
happyOut21 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t21
happyOut21 x = unsafeCoerce# x
{-# INLINE happyOut21 #-}
happyIn22 :: t22 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn22 x = unsafeCoerce# x
{-# INLINE happyIn22 #-}
happyOut22 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t22
happyOut22 x = unsafeCoerce# x
{-# INLINE happyOut22 #-}
happyIn23 :: t23 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn23 x = unsafeCoerce# x
{-# INLINE happyIn23 #-}
happyOut23 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t23
happyOut23 x = unsafeCoerce# x
{-# INLINE happyOut23 #-}
happyIn24 :: t24 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn24 x = unsafeCoerce# x
{-# INLINE happyIn24 #-}
happyOut24 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t24
happyOut24 x = unsafeCoerce# x
{-# INLINE happyOut24 #-}
happyIn25 :: t25 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn25 x = unsafeCoerce# x
{-# INLINE happyIn25 #-}
happyOut25 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t25
happyOut25 x = unsafeCoerce# x
{-# INLINE happyOut25 #-}
happyIn26 :: t26 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn26 x = unsafeCoerce# x
{-# INLINE happyIn26 #-}
happyOut26 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t26
happyOut26 x = unsafeCoerce# x
{-# INLINE happyOut26 #-}
happyIn27 :: t27 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn27 x = unsafeCoerce# x
{-# INLINE happyIn27 #-}
happyOut27 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t27
happyOut27 x = unsafeCoerce# x
{-# INLINE happyOut27 #-}
happyIn28 :: t28 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn28 x = unsafeCoerce# x
{-# INLINE happyIn28 #-}
happyOut28 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t28
happyOut28 x = unsafeCoerce# x
{-# INLINE happyOut28 #-}
happyIn29 :: t29 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn29 x = unsafeCoerce# x
{-# INLINE happyIn29 #-}
happyOut29 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t29
happyOut29 x = unsafeCoerce# x
{-# INLINE happyOut29 #-}
happyIn30 :: t30 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn30 x = unsafeCoerce# x
{-# INLINE happyIn30 #-}
happyOut30 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t30
happyOut30 x = unsafeCoerce# x
{-# INLINE happyOut30 #-}
happyIn31 :: t31 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn31 x = unsafeCoerce# x
{-# INLINE happyIn31 #-}
happyOut31 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t31
happyOut31 x = unsafeCoerce# x
{-# INLINE happyOut31 #-}
happyIn32 :: t32 -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyIn32 x = unsafeCoerce# x
{-# INLINE happyIn32 #-}
happyOut32 :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> t32
happyOut32 x = unsafeCoerce# x
{-# INLINE happyOut32 #-}
happyInTok :: Token -> (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32)
happyInTok x = unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22 t23 t24 t25 t26 t27 t28 t29 t30 t31 t32) -> Token
happyOutTok x = unsafeCoerce# x
{-# INLINE happyOutTok #-}

happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\x4f\x00\x00\x00\x00\x00\x07\x01\x05\x01\x05\x01\x0d\x00\x00\x00\x60\x00\x00\x00\x00\x00\x00\x00\x01\x00\x13\x01\x00\x00\x00\x00\x68\x00\x00\x00\x00\x00\x00\x00\x23\x01\x00\x00\x4f\x00\x00\x00\x18\x01\x7e\x00\x7e\x00\x09\x01\x13\x01\x00\x00\x00\x00\xf1\x00\x00\x00\xff\x00\x00\x01\xd6\x00\x2a\x00\xfe\x00\x00\x00\x17\x00\x3e\x00\x2d\x00\xea\x00\x00\x00\xc2\x00\x00\x00\x7e\x00\xc1\x00\x00\x00\x05\x00\x24\x00\x4c\x00\x11\x00\xca\x00\xc9\x00\xba\x00\xa1\x00\x95\x00\x00\x00\x00\x00\x00\x00\x13\x01\x2d\x00\x00\x00\x00\x00\x2d\x00\x05\x00\x92\x00\x2d\x00\x65\x00\x9b\x00\x00\x00\x00\x00\x2d\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x69\x00\x00\x00\x00\x00\x00\x00\x4c\x00\x4c\x00\x4c\x00\x80\x00\x00\x00\x2d\x00\x13\x01\x7e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x61\x00\x00\x00\x2d\x00\x3f\x00\x00\x00\x00\x00\x00\x00\x53\x00\x00\x00\x2d\x00\x4c\x00\x47\x00\x2d\x00\x47\x00\x00\x00\x51\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\xef\x00\x08\x00\x3b\x00\x1f\x01\x00\x00\x00\x00\x31\x00\x00\x00\x29\x00\x00\x00\x00\x00\x00\x00\x86\x00\xf9\x00\x00\x00\x00\x00\x1e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x96\x00\x00\x00\x00\x00\x73\x00\x70\x00\x00\x00\xf2\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe8\x00\xf6\x00\xdf\x00\x00\x00\x00\x00\x00\x00\x00\x00\x5c\x00\x1c\x01\x00\x00\x41\x00\x2b\x00\x1b\x00\x6d\x00\x00\x00\x00\x00\x00\x00\x19\x01\x00\x00\x00\x00\x00\x00\x00\x00\x81\x00\xd8\x00\x00\x00\x00\x00\xcf\x00\x22\x00\x00\x00\xc8\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x3d\x00\x38\x00\x04\x00\x00\x00\x00\x00\xbf\x00\xfd\x00\x58\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb8\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xaf\x00\xfc\xff\x03\x00\xa8\x00\xf8\xff\x00\x00\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\x00\x00\xbf\xff\x00\x00\xf8\xff\x00\x00\x00\x00\xe3\xff\xe1\xff\xde\xff\xdc\xff\xda\xff\xdb\xff\x00\x00\x00\x00\xc1\xff\xd6\xff\x00\x00\xd4\xff\xd5\xff\xd3\xff\x00\x00\xd8\xff\xd0\xff\xe6\xff\x00\x00\xf1\xff\xf1\xff\x00\x00\xca\xff\xc3\xff\xc2\xff\x00\x00\xc4\xff\x00\x00\x00\x00\xc8\xff\xdb\xff\x00\x00\xdd\xff\x00\x00\x00\x00\x00\x00\x00\x00\xd1\xff\xfb\xff\xfd\xff\xf1\xff\xf8\xff\xf9\xff\x00\x00\xf0\xff\x00\x00\xcc\xff\x00\x00\x00\x00\x00\x00\xf8\xff\x00\x00\xe4\xff\xe2\xff\xc0\xff\x00\x00\x00\x00\xd7\xff\xc9\xff\x00\x00\x00\x00\x00\x00\x00\x00\xce\xff\x00\x00\xcf\xff\xd9\xff\x00\x00\xdf\xff\xf7\xff\xf6\xff\xf4\xff\xf5\xff\xe0\xff\x00\x00\xc7\xff\xd2\xff\xfa\xff\x00\x00\x00\x00\x00\x00\x00\x00\xcb\xff\x00\x00\x00\x00\xf1\xff\xf3\xff\xf2\xff\xfc\xff\xef\xff\x00\x00\xec\xff\x00\x00\xc6\xff\xeb\xff\xea\xff\xe9\xff\x00\x00\xcd\xff\x00\x00\x00\x00\xe8\xff\x00\x00\xe8\xff\xee\xff\x00\x00\xc5\xff\xe5\xff\xe7\xff\xed\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x09\x00\x01\x00\x04\x00\x03\x00\x00\x00\x05\x00\x06\x00\x00\x00\x0a\x00\x09\x00\x0a\x00\x09\x00\x11\x00\x0d\x00\x0e\x00\x0f\x00\x04\x00\x01\x00\x17\x00\x13\x00\x11\x00\x05\x00\x06\x00\x01\x00\x08\x00\x03\x00\x17\x00\x17\x00\x06\x00\x1d\x00\x1e\x00\x09\x00\x0a\x00\x04\x00\x1b\x00\x0d\x00\x0e\x00\x0f\x00\x05\x00\x0a\x00\x1c\x00\x13\x00\x1e\x00\x11\x00\x1c\x00\x01\x00\x1e\x00\x03\x00\x06\x00\x08\x00\x06\x00\x1d\x00\x1e\x00\x09\x00\x0a\x00\x0f\x00\x10\x00\x0d\x00\x0e\x00\x0f\x00\x19\x00\x1a\x00\x01\x00\x13\x00\x03\x00\x11\x00\x1a\x00\x06\x00\x1b\x00\x05\x00\x09\x00\x0a\x00\x11\x00\x1d\x00\x0d\x00\x0e\x00\x0f\x00\x11\x00\x17\x00\x01\x00\x13\x00\x03\x00\x0c\x00\x17\x00\x06\x00\x1b\x00\x04\x00\x09\x00\x0a\x00\x1b\x00\x1d\x00\x0d\x00\x0e\x00\x0f\x00\x07\x00\x08\x00\x01\x00\x13\x00\x07\x00\x08\x00\x14\x00\x06\x00\x16\x00\x1c\x00\x09\x00\x1e\x00\x02\x00\x1d\x00\x0d\x00\x0e\x00\x0f\x00\x18\x00\x19\x00\x1a\x00\x13\x00\x18\x00\x19\x00\x1a\x00\x07\x00\x08\x00\x18\x00\x07\x00\x08\x00\x14\x00\x1d\x00\x16\x00\x01\x00\x1b\x00\x14\x00\x15\x00\x05\x00\x06\x00\x18\x00\x19\x00\x1a\x00\x18\x00\x19\x00\x1a\x00\x18\x00\x19\x00\x1a\x00\x10\x00\x11\x00\x12\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x16\x00\x18\x00\x18\x00\x19\x00\x1a\x00\x16\x00\x02\x00\x18\x00\x19\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x15\x00\x12\x00\x13\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1a\x00\x1c\x00\x13\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1f\x00\x07\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x07\x00\x07\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1f\x00\x1f\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x06\x00\x1b\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x1a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x02\x00\x02\x00\x1a\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x15\x00\x08\x00\x1a\x00\x18\x00\x19\x00\x1a\x00\x04\x00\x15\x00\x1e\x00\x1a\x00\x18\x00\x19\x00\x1a\x00\x01\x00\x18\x00\x19\x00\x1a\x00\x05\x00\x06\x00\x01\x00\x02\x00\x03\x00\x01\x00\x02\x00\x03\x00\x01\x00\x02\x00\x03\x00\x0b\x00\x01\x00\x20\x00\x1f\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\x73\x00\x0d\x00\x17\x00\x0e\x00\x4e\x00\x21\x00\x0f\x00\x04\x00\x72\x00\x10\x00\x11\x00\x6e\x00\x63\x00\x12\x00\x13\x00\x14\x00\x2a\x00\x20\x00\x70\x00\x15\x00\x63\x00\x21\x00\x0f\x00\x0d\x00\x5a\x00\x0e\x00\x64\x00\x4f\x00\x0f\x00\x16\x00\x26\x00\x10\x00\x11\x00\x17\x00\x03\x00\x12\x00\x13\x00\x14\x00\x4c\x00\x18\x00\x2b\x00\x15\x00\x2c\x00\x5a\x00\xc2\xff\x0d\x00\xc2\xff\x0e\x00\x5b\x00\xc2\xff\x0f\x00\x16\x00\x26\x00\x10\x00\x11\x00\x26\x00\x0a\x00\x12\x00\x13\x00\x14\x00\x5d\x00\x5e\x00\x28\x00\x15\x00\x0e\x00\x28\x00\x0b\x00\x0f\x00\xc2\xff\x5e\x00\x10\x00\x11\x00\x63\x00\x16\x00\x12\x00\x13\x00\x14\x00\x63\x00\x65\x00\x0d\x00\x15\x00\x0e\x00\x70\x00\x66\x00\x0f\x00\x03\x00\x6a\x00\x10\x00\x11\x00\x6b\x00\x16\x00\x12\x00\x13\x00\x14\x00\x5f\x00\x32\x00\x28\x00\x15\x00\x31\x00\x32\x00\x1a\x00\x0f\x00\x1b\x00\x2b\x00\x10\x00\x2c\x00\x68\x00\x16\x00\x12\x00\x13\x00\x14\x00\x33\x00\x1d\x00\x34\x00\x15\x00\x33\x00\x1d\x00\x34\x00\x42\x00\x32\x00\x6d\x00\x43\x00\x32\x00\x1a\x00\x16\x00\x1b\x00\x20\x00\x4a\x00\x57\x00\x58\x00\x21\x00\x0f\x00\x1c\x00\x1d\x00\x1e\x00\x33\x00\x1d\x00\x34\x00\x33\x00\x1d\x00\x34\x00\x36\x00\x37\x00\x38\x00\x21\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x51\x00\x63\x00\x23\x00\x1d\x00\x1e\x00\x22\x00\x49\x00\x23\x00\x1d\x00\x24\x00\x45\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x4c\x00\x46\x00\x47\x00\x45\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x53\x00\x68\x00\x6d\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x71\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x30\x00\x55\x00\x0b\x00\x6b\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x61\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x56\x00\x57\x00\x0b\x00\x4a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x4f\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x30\x00\x39\x00\x0b\x00\x50\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x3a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x3a\x00\x3e\x00\x0b\x00\x21\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x3d\x00\x40\x00\x0b\x00\x3b\x00\x08\x00\x09\x00\x0a\x00\x40\x00\x3f\x00\x0b\x00\x1c\x00\x1d\x00\x1e\x00\x42\x00\x1b\x00\x26\x00\x0b\x00\x1c\x00\x1d\x00\x1e\x00\x20\x00\x60\x00\x1d\x00\x1e\x00\x21\x00\x0f\x00\x2c\x00\x53\x00\x2e\x00\x2c\x00\x30\x00\x2e\x00\x2c\x00\x2d\x00\x2e\x00\x45\x00\x17\x00\xff\xff\x30\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = array (2, 64) [
	(2 , happyReduce_2),
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38),
	(39 , happyReduce_39),
	(40 , happyReduce_40),
	(41 , happyReduce_41),
	(42 , happyReduce_42),
	(43 , happyReduce_43),
	(44 , happyReduce_44),
	(45 , happyReduce_45),
	(46 , happyReduce_46),
	(47 , happyReduce_47),
	(48 , happyReduce_48),
	(49 , happyReduce_49),
	(50 , happyReduce_50),
	(51 , happyReduce_51),
	(52 , happyReduce_52),
	(53 , happyReduce_53),
	(54 , happyReduce_54),
	(55 , happyReduce_55),
	(56 , happyReduce_56),
	(57 , happyReduce_57),
	(58 , happyReduce_58),
	(59 , happyReduce_59),
	(60 , happyReduce_60),
	(61 , happyReduce_61),
	(62 , happyReduce_62),
	(63 , happyReduce_63),
	(64 , happyReduce_64)
	]

happy_n_terms = 33 :: Int
happy_n_nonterms = 28 :: Int

happyReduce_2 = happySpecReduce_2 0# happyReduction_2
happyReduction_2 happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_2 of { happy_var_2 -> 
	happyIn5
		 (happy_var_2
	)}

happyReduce_3 = happySpecReduce_3 1# happyReduction_3
happyReduction_3 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_2 of { happy_var_2 -> 
	happyIn6
		 (happy_var_2
	)}

happyReduce_4 = happySpecReduce_1 2# happyReduction_4
happyReduction_4 happy_x_1
	 =  case happyOut6 happy_x_1 of { happy_var_1 -> 
	happyIn7
		 (happy_var_1
	)}

happyReduce_5 = happySpecReduce_3 2# happyReduction_5
happyReduction_5 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut6 happy_x_1 of { happy_var_1 -> 
	case happyOut7 happy_x_3 of { happy_var_3 -> 
	happyIn7
		 (happy_var_1 ++ happy_var_3
	)}}

happyReduce_6 = happySpecReduce_2 2# happyReduction_6
happyReduction_6 happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_2 of { happy_var_2 -> 
	happyIn7
		 (happy_var_2
	)}

happyReduce_7 = happyMonadReduce 0# 3# happyReduction_7
happyReduction_7 (happyRest)
	 = happyThen ( pushCurrentContext
	) (\r -> happyReturn (happyIn8 r))

happyReduce_8 = happySpecReduce_3 4# happyReduction_8
happyReduction_8 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_2 of { happy_var_2 -> 
	happyIn9
		 (happy_var_2
	)}

happyReduce_9 = happySpecReduce_3 4# happyReduction_9
happyReduction_9 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut12 happy_x_2 of { happy_var_2 -> 
	happyIn9
		 (happy_var_2
	)}

happyReduce_10 = happySpecReduce_1 5# happyReduction_10
happyReduction_10 happy_x_1
	 =  happyIn10
		 (()
	)

happyReduce_11 = happyMonadReduce 1# 5# happyReduction_11
happyReduction_11 (happy_x_1 `HappyStk`
	happyRest)
	 = happyThen ( popContext
	) (\r -> happyReturn (happyIn10 r))

happyReduce_12 = happySpecReduce_1 6# happyReduction_12
happyReduction_12 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TkSemi happy_var_1) -> 
	happyIn11
		 (happy_var_1
	)}

happyReduce_13 = happySpecReduce_1 6# happyReduction_13
happyReduction_13 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TkVSemi happy_var_1) -> 
	happyIn11
		 (happy_var_1
	)}

happyReduce_14 = happySpecReduce_0 7# happyReduction_14
happyReduction_14  =  happyIn12
		 ([]
	)

happyReduce_15 = happySpecReduce_1 7# happyReduction_15
happyReduction_15 happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	happyIn12
		 ([happy_var_1]
	)}

happyReduce_16 = happySpecReduce_3 7# happyReduction_16
happyReduction_16 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut13 happy_x_1 of { happy_var_1 -> 
	case happyOut12 happy_x_3 of { happy_var_3 -> 
	happyIn12
		 (happy_var_1:happy_var_3
	)}}

happyReduce_17 = happyReduce 5# 8# happyReduction_17
happyReduction_17 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut31 happy_x_1 of { happy_var_1 -> 
	case happyOut25 happy_x_2 of { happy_var_2 -> 
	case happyOut16 happy_x_4 of { happy_var_4 -> 
	case happyOut14 happy_x_5 of { happy_var_5 -> 
	happyIn13
		 (mkFunClause happy_var_1 happy_var_2 happy_var_4 happy_var_5
	) `HappyStk` happyRest}}}}

happyReduce_18 = happyReduce 6# 8# happyReduction_18
happyReduction_18 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut22 happy_x_2 of { happy_var_2 -> 
	case happyOut29 happy_x_3 of { happy_var_3 -> 
	case happyOut16 happy_x_5 of { happy_var_5 -> 
	case happyOut14 happy_x_6 of { happy_var_6 -> 
	happyIn13
		 (mkFunClause happy_var_2 [happy_var_1,happy_var_3] happy_var_5 happy_var_6
	) `HappyStk` happyRest}}}}}

happyReduce_19 = happySpecReduce_3 8# happyReduction_19
happyReduction_19 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	case happyOut16 happy_x_3 of { happy_var_3 -> 
	happyIn13
		 (TypeSig happy_var_1 happy_var_3
	)}}

happyReduce_20 = happySpecReduce_3 8# happyReduction_20
happyReduction_20 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TkInt (_,happy_var_2)) -> 
	case happyOut28 happy_x_3 of { happy_var_3 -> 
	happyIn13
		 (mkInfix NonAssoc happy_var_2 happy_var_3
	)}}

happyReduce_21 = happySpecReduce_3 8# happyReduction_21
happyReduction_21 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TkInt (_,happy_var_2)) -> 
	case happyOut28 happy_x_3 of { happy_var_3 -> 
	happyIn13
		 (mkInfix LeftAssoc happy_var_2 happy_var_3
	)}}

happyReduce_22 = happySpecReduce_3 8# happyReduction_22
happyReduction_22 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TkInt (_,happy_var_2)) -> 
	case happyOut28 happy_x_3 of { happy_var_3 -> 
	happyIn13
		 (mkInfix RightAssoc happy_var_2 happy_var_3
	)}}

happyReduce_23 = happySpecReduce_0 9# happyReduction_23
happyReduction_23  =  happyIn14
		 ([]
	)

happyReduce_24 = happySpecReduce_2 9# happyReduction_24
happyReduction_24 happy_x_2
	happy_x_1
	 =  case happyOut15 happy_x_2 of { happy_var_2 -> 
	happyIn14
		 (happy_var_2
	)}

happyReduce_25 = happySpecReduce_1 10# happyReduction_25
happyReduction_25 happy_x_1
	 =  case happyOut9 happy_x_1 of { happy_var_1 -> 
	happyIn15
		 (happy_var_1
	)}

happyReduce_26 = happyReduce 7# 11# happyReduction_26
happyReduction_26 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut27 happy_x_2 of { happy_var_2 -> 
	case happyOut16 happy_x_4 of { happy_var_4 -> 
	case happyOut16 happy_x_7 of { happy_var_7 -> 
	happyIn16
		 (mkPi happy_var_2 happy_var_4 happy_var_7
	) `HappyStk` happyRest}}}

happyReduce_27 = happySpecReduce_3 11# happyReduction_27
happyReduction_27 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	case happyOut16 happy_x_3 of { happy_var_3 -> 
	happyIn16
		 (Pi "_" happy_var_1 happy_var_3
	)}}

happyReduce_28 = happySpecReduce_1 11# happyReduction_28
happyReduction_28 happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	happyIn16
		 (happy_var_1
	)}

happyReduce_29 = happySpecReduce_3 12# happyReduction_29
happyReduction_29 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut17 happy_x_1 of { happy_var_1 -> 
	case happyOut22 happy_x_2 of { happy_var_2 -> 
	case happyOut18 happy_x_3 of { happy_var_3 -> 
	happyIn17
		 (InfixApp happy_var_1 happy_var_2 happy_var_3
	)}}}

happyReduce_30 = happySpecReduce_1 12# happyReduction_30
happyReduction_30 happy_x_1
	 =  case happyOut18 happy_x_1 of { happy_var_1 -> 
	happyIn17
		 (happy_var_1
	)}

happyReduce_31 = happyReduce 4# 13# happyReduction_31
happyReduction_31 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut26 happy_x_2 of { happy_var_2 -> 
	case happyOut16 happy_x_4 of { happy_var_4 -> 
	happyIn18
		 (mkLam happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_32 = happyReduce 4# 13# happyReduction_32
happyReduction_32 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut15 happy_x_2 of { happy_var_2 -> 
	case happyOut16 happy_x_4 of { happy_var_4 -> 
	happyIn18
		 (Let happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_33 = happySpecReduce_1 13# happyReduction_33
happyReduction_33 happy_x_1
	 =  case happyOut19 happy_x_1 of { happy_var_1 -> 
	happyIn18
		 (happy_var_1
	)}

happyReduce_34 = happySpecReduce_2 14# happyReduction_34
happyReduction_34 happy_x_2
	happy_x_1
	 =  case happyOut19 happy_x_1 of { happy_var_1 -> 
	case happyOut20 happy_x_2 of { happy_var_2 -> 
	happyIn19
		 (App happy_var_1 happy_var_2
	)}}

happyReduce_35 = happySpecReduce_1 14# happyReduction_35
happyReduction_35 happy_x_1
	 =  case happyOut20 happy_x_1 of { happy_var_1 -> 
	happyIn19
		 (happy_var_1
	)}

happyReduce_36 = happySpecReduce_1 15# happyReduction_36
happyReduction_36 happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	happyIn20
		 (Name happy_var_1
	)}

happyReduce_37 = happySpecReduce_1 15# happyReduction_37
happyReduction_37 happy_x_1
	 =  case happyOut21 happy_x_1 of { happy_var_1 -> 
	happyIn20
		 (happy_var_1
	)}

happyReduce_38 = happyReduce 4# 15# happyReduction_38
happyReduction_38 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_1 of { (TkPlugin (_,happy_var_1)) -> 
	case happyOut23 happy_x_3 of { happy_var_3 -> 
	happyIn20
		 (CallPlugin happy_var_1 happy_var_3
	) `HappyStk` happyRest}}

happyReduce_39 = happySpecReduce_1 15# happyReduction_39
happyReduction_39 happy_x_1
	 =  happyIn20
		 (CallPlugin "assert" []
	)

happyReduce_40 = happySpecReduce_3 15# happyReduction_40
happyReduction_40 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut16 happy_x_2 of { happy_var_2 -> 
	happyIn20
		 (Paren happy_var_2
	)}

happyReduce_41 = happySpecReduce_1 16# happyReduction_41
happyReduction_41 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TkUniverse (_,happy_var_1)) -> 
	happyIn21
		 (Star (Univ happy_var_1)
	)}

happyReduce_42 = happySpecReduce_1 16# happyReduction_42
happyReduction_42 happy_x_1
	 =  happyIn21
		 (Prop
	)

happyReduce_43 = happySpecReduce_1 16# happyReduction_43
happyReduction_43 happy_x_1
	 =  happyIn21
		 (Star (Univ 0)
	)

happyReduce_44 = happySpecReduce_1 16# happyReduction_44
happyReduction_44 happy_x_1
	 =  happyIn21
		 (Star (Univ 1)
	)

happyReduce_45 = happySpecReduce_3 17# happyReduction_45
happyReduction_45 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TkId (_,happy_var_2)) -> 
	happyIn22
		 (happy_var_2
	)}

happyReduce_46 = happySpecReduce_1 17# happyReduction_46
happyReduction_46 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TkOp (_,happy_var_1)) -> 
	happyIn22
		 (happy_var_1
	)}

happyReduce_47 = happySpecReduce_0 18# happyReduction_47
happyReduction_47  =  happyIn23
		 ([]
	)

happyReduce_48 = happySpecReduce_1 18# happyReduction_48
happyReduction_48 happy_x_1
	 =  case happyOut24 happy_x_1 of { happy_var_1 -> 
	happyIn23
		 (happy_var_1
	)}

happyReduce_49 = happySpecReduce_1 19# happyReduction_49
happyReduction_49 happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	happyIn24
		 ([happy_var_1]
	)}

happyReduce_50 = happySpecReduce_3 19# happyReduction_50
happyReduction_50 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut16 happy_x_1 of { happy_var_1 -> 
	case happyOut24 happy_x_3 of { happy_var_3 -> 
	happyIn24
		 (happy_var_1 : happy_var_3
	)}}

happyReduce_51 = happySpecReduce_0 20# happyReduction_51
happyReduction_51  =  happyIn25
		 ([]
	)

happyReduce_52 = happySpecReduce_1 20# happyReduction_52
happyReduction_52 happy_x_1
	 =  case happyOut26 happy_x_1 of { happy_var_1 -> 
	happyIn25
		 (happy_var_1
	)}

happyReduce_53 = happySpecReduce_1 21# happyReduction_53
happyReduction_53 happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	happyIn26
		 ([happy_var_1]
	)}

happyReduce_54 = happySpecReduce_2 21# happyReduction_54
happyReduction_54 happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut26 happy_x_2 of { happy_var_2 -> 
	happyIn26
		 (happy_var_1 : happy_var_2
	)}}

happyReduce_55 = happySpecReduce_1 22# happyReduction_55
happyReduction_55 happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	happyIn27
		 ([happy_var_1]
	)}

happyReduce_56 = happySpecReduce_3 22# happyReduction_56
happyReduction_56 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut29 happy_x_1 of { happy_var_1 -> 
	case happyOut27 happy_x_3 of { happy_var_3 -> 
	happyIn27
		 (happy_var_1 : happy_var_3
	)}}

happyReduce_57 = happySpecReduce_1 23# happyReduction_57
happyReduction_57 happy_x_1
	 =  case happyOut22 happy_x_1 of { happy_var_1 -> 
	happyIn28
		 ([happy_var_1]
	)}

happyReduce_58 = happySpecReduce_3 23# happyReduction_58
happyReduction_58 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut22 happy_x_1 of { happy_var_1 -> 
	case happyOut28 happy_x_3 of { happy_var_3 -> 
	happyIn28
		 (happy_var_1 : happy_var_3
	)}}

happyReduce_59 = happySpecReduce_1 24# happyReduction_59
happyReduction_59 happy_x_1
	 =  happyIn29
		 ("_"
	)

happyReduce_60 = happySpecReduce_1 24# happyReduction_60
happyReduction_60 happy_x_1
	 =  case happyOut30 happy_x_1 of { happy_var_1 -> 
	happyIn29
		 (happy_var_1
	)}

happyReduce_61 = happySpecReduce_1 25# happyReduction_61
happyReduction_61 happy_x_1
	 =  case happyOut31 happy_x_1 of { happy_var_1 -> 
	happyIn30
		 (happy_var_1
	)}

happyReduce_62 = happySpecReduce_1 26# happyReduction_62
happyReduction_62 happy_x_1
	 =  case happyOutTok happy_x_1 of { (TkId (_,happy_var_1)) -> 
	happyIn31
		 (happy_var_1
	)}

happyReduce_63 = happySpecReduce_3 26# happyReduction_63
happyReduction_63 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (TkOp (_,happy_var_2)) -> 
	happyIn31
		 (happy_var_2
	)}

happyReduce_64 = happySpecReduce_0 27# happyReduction_64
happyReduction_64  =  happyIn32
		 (
	)

happyNewToken action sts stk
	= lexer(\tk -> 
	let cont i = happyDoAction i tk action sts stk in
	case tk of {
	TkEOF -> happyDoAction 32# (error "reading EOF!") action sts stk;
	TkLParen happy_dollar_dollar -> cont 1#;
	TkRParen happy_dollar_dollar -> cont 2#;
	TkLambda happy_dollar_dollar -> cont 3#;
	TkArrow happy_dollar_dollar -> cont 4#;
	TkUnderscore happy_dollar_dollar -> cont 5#;
	TkId (_,happy_dollar_dollar) -> cont 6#;
	TkInt (_,happy_dollar_dollar) -> cont 7#;
	TkDblColon happy_dollar_dollar -> cont 8#;
	TkUniverse (_,happy_dollar_dollar) -> cont 9#;
	TkLet happy_dollar_dollar -> cont 10#;
	TkIn happy_dollar_dollar -> cont 11#;
	TkWhere happy_dollar_dollar -> cont 12#;
	TkSet happy_dollar_dollar -> cont 13#;
	TkProp happy_dollar_dollar -> cont 14#;
	TkType happy_dollar_dollar -> cont 15#;
	TkInfix happy_dollar_dollar -> cont 16#;
	TkInfixL happy_dollar_dollar -> cont 17#;
	TkInfixR happy_dollar_dollar -> cont 18#;
	TkPlugin (_,happy_dollar_dollar) -> cont 19#;
	TkOpenBrace happy_dollar_dollar -> cont 20#;
	TkCloseBrace happy_dollar_dollar -> cont 21#;
	TkVOpenBrace happy_dollar_dollar -> cont 22#;
	TkVCloseBrace happy_dollar_dollar -> cont 23#;
	TkEqual happy_dollar_dollar -> cont 24#;
	TkSemi happy_dollar_dollar -> cont 25#;
	TkVSemi happy_dollar_dollar -> cont 26#;
	TkComma happy_dollar_dollar -> cont 27#;
	TkBackQuote happy_dollar_dollar -> cont 28#;
	TkOp (happy_dollar_dollar,"?") -> cont 29#;
	TkOp (_,happy_dollar_dollar) -> cont 30#;
	TkTeX happy_dollar_dollar -> cont 31#;
	_ -> happyError'
	})

happyError_ tk = happyError'

happyThen :: () => Parser a -> (a -> Parser b) -> Parser b
happyThen = (>>=)
happyReturn :: () => a -> Parser a
happyReturn = (return)
happyThen1 = happyThen
happyReturn1 :: () => a -> Parser a
happyReturn1 = happyReturn
happyError' :: () => Parser a
happyError' = happyError

termParser = happySomeParser where
  happySomeParser = happyThen (happyParse 0#) (\x -> happyReturn (happyOut16 x))

programParser = happySomeParser where
  happySomeParser = happyThen (happyParse 1#) (\x -> happyReturn (happyOut5 x))

happySeq = happyDontSeq

-- Parsing

parse :: Parser a -> String -> ParseResult a
parse p = parse' 0 p

parseFile :: Parser a -> FilePath -> IO (ParseResult a)
parseFile p = parseFile' 0 p

parseLiterate :: Parser a -> String -> ParseResult a
parseLiterate p = parse' tex p

parseLiterateFile :: Parser a -> FilePath -> IO (ParseResult a)
parseLiterateFile p = parseFile' tex p

programParser	:: Parser Program
termParser	:: Parser Term

happyError = fail "Parse error"

oneofId xs y
    | elem y xs	= return y
    | otherwise	= fail $ "Expected one of " ++ unwords xs

-- | Even though this function is not exported, I want it to show up
--   in the documentation.
mkLam :: [Name] -> Term -> Term
mkLam vs t = foldr Lam t vs

mkPi :: [Name] -> Term -> Term -> Term
mkPi xs t u = foldr (\x -> Pi x t) u xs

mkInfix :: Assoc -> Precedence -> [Name] -> Decl
mkInfix ass pr vs = Infix ass pr vs

mkFunClause :: Name -> [Name] -> Term -> [Decl] -> Decl
mkFunClause x xs e [] = FunClause x (mkLam xs e)
mkFunClause x xs e ds	= FunClause x (mkLam xs $ Let ds e)
{-# LINE 1 "GenericTemplate.hs" #-}
#pragma GCC set_debug_pwd "/usr/local/src/haskell/happy/happy-1.15/happy/templates"
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command line>" #-}
{-# LINE 1 "GenericTemplate.hs" #-}
-- $Id$


{-# LINE 28 "GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Int# Happy_IntList






{-# LINE 49 "GenericTemplate.hs" #-}


{-# LINE 59 "GenericTemplate.hs" #-}

{-# LINE 68 "GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	(happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
	= {- nothing -}


	  case action of
		0#		  -> {- nothing -}
				     happyFail i tk st
		-1# 	  -> {- nothing -}
				     happyAccept i tk st
		n | (n <# (0# :: Int#)) -> {- nothing -}

				     (happyReduceArr ! rule) i tk st
				     where rule = (I# ((negateInt# ((n +# (1# :: Int#))))))
		n		  -> {- nothing -}


				     happyShift new_state i tk st
				     where new_state = (n -# (1# :: Int#))
   where off    = indexShortOffAddr happyActOffsets st
	 off_i  = (off +# i)
	 check  = if (off_i >=# (0# :: Int#))
			then (indexShortOffAddr happyCheck off_i ==#  i)
			else False
 	 action | check     = indexShortOffAddr happyTable off_i
		| otherwise = indexShortOffAddr happyDefActions st











indexShortOffAddr (HappyA# arr) off =
#if __GLASGOW_HASKELL__ > 500
	narrow16Int# i
#elif __GLASGOW_HASKELL__ == 500
	intToInt16# i
#else
	(i `iShiftL#` 16#) `iShiftRA#` 16#
#endif
  where
#if __GLASGOW_HASKELL__ >= 503
	i = word2Int# ((high `uncheckedShiftL#` 8#) `or#` low)
#else
	i = word2Int# ((high `shiftL#` 8#) `or#` low)
#endif
	high = int2Word# (ord# (indexCharOffAddr# arr (off' +# 1#)))
	low  = int2Word# (ord# (indexCharOffAddr# arr off'))
	off' = off *# 2#





data HappyAddr = HappyA# Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 170 "GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case unsafeCoerce# x of { (I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k -# (1# :: Int#)) sts of
	 sts1@((HappyCons (st1@(action)) (_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@((HappyCons (st1@(action)) (_))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n -# (1# :: Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n -# (1#::Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off    = indexShortOffAddr happyGotoOffsets st
	 off_i  = (off +# nt)
 	 new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail  0# tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
	happyDoAction 0# tk action sts ( (unsafeCoerce# (I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
