
module Plugins.Skeleton where

import Control.Monad.Trans

import Syntax.Position
import Syntax.Internal
import Syntax.Values

import TypeChecker.Monad
import TypeChecker.Monad.Errors
import TypeChecker.Errors

import Utils.Error

import Plugins

plugin :: SomePlugin
plugin = mkPlugin $ 
    Plugin  { plName		= "skeleton"
            , plHelp            = help
	    , plInit		= initialize
	    , plFinal		= finalize
	    , plCheck		= check
	    , plInfer		= infer
	    , plOptions		= options
	    , plDefaultOptions	= defaultOptions
	    }

type State = ()
type Options = ()

help = "This is the skeleton for a plugin. Insert code in appropriate places."

initialize :: Options -> TC State
initialize _ = return ()

finalize :: Options -> State -> TC ()
finalize _ _ = return ()

check :: Options -> State -> Range -> [Term] -> Type -> TC (Value, State)
check _ _ _ _ _ = failure $ customError "The plugin skeleton doesn't actually do anything"

infer :: Options -> State -> Range -> [Term] -> TC (Value, Type, State)
infer _ _ _ _ = failure $ customError "The plugin skeleton doesn't actually do anything"

options :: PluginOptions Options
options = simpleOptions []

defaultOptions :: Options
defaultOptions = ()

