
infixr 10 ::
infix 5 ∈, ==

data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

data Bool : Set where
  true, false : Bool

data List (A:Set) : Set where
  nil : List A
  (::) : A -> List A -> List A

filter (A:Set) : (A -> Bool) -> List A -> List A
filter p [] = []
filter	  p (x :: xs) with p x =>
  filter' p (x :: xs) true  = x :: filter p xs
  filter' p (x :: xs) false = filter p xs

data (==) {A:Set}(x:A) : A -> Set where
  refl : x == x

subst (A:Set)(x, y : A) : (P : A -> Set) -> x == y -> P x -> P y
subst P refl px = px

data (∈) {A:Set}(x:A) : List A -> Set where
  inHead      (xs:List A) :	      x ∈ x :: xs
  inTail (y:A)(xs:List A) : x ∈ xs -> x ∈ y :: xs

data False : Set where

¬ : Set -> Set
¬ A = A -> False

(∉) (A:Set) : A -> List A -> Set
x ∉ xs = ¬ (x ∈ xs)

data Inspect {A:Set}(x:A) : Set where
  it : (y:A) -> x == y -> Inspect x

inspect (A:Set) : (x:A) -> Inspect x
inspect x = it x refl

trueNotFalse (x:Bool) : x == true -> x == false -> False
trueNotFalse refl ()

-- In the proof we need to refer to the auxiliary function filter'.
-- It's a bit annoying that we can't do the subst in a local function.
filterNotElem (A:Set) : (p : A -> Bool) -> (z : A) -> (xs : List A) ->
			p z == false -> z ∉ filter p xs
filterNotElem p z [] _ ()
filterNotElem p z (x :: xs) eq el with inspect (p x) =>

  _ p z (x :: xs) _ el (it true  "px=1" )
    with let el' : z ∈ x :: filter p xs
	     el' = subst (\px -> z ∈ filter' _ p x xs px) "px=1" el
	 in  el' =>

    _ p x (x :: xs) "px=0" _ (it _ "px=1") inHead     = trueNotFalse "px=1" "px=0"
      where 
      trueNotFalse (x:Bool) : x == true -> x == false -> False
      trueNotFalse refl ()

    _ p z (x :: xs) eq	   _  _		  (inTail el) = filterNotElem p z xs eq el

  _ p z (x :: xs) eq el (it false "px=0")
    with let el' : z ∈ filter p xs
	     el' = subst (\px -> z ∈ filter' _ p x xs px) "px=0" el
	 in  el' =>
    _ p z (x :: xs) "px=0" _ _ el = filterNotElem p z xs "px=0" el


